--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_mips1900.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_mips1900.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,196 @@
+
+#include <linux/module.h>
+#include <linux/types.h>
+#include <linux/kernel.h>
+#include <linux/fs.h>
+#include <linux/miscdevice.h>
+#include <linux/init.h>
+#include <linux/ioport.h>
+#include <asm/uaccess.h>
+#include <asm/io.h>
+#include <linux/semaphore.h>
+
+#include <linux/sched.h>
+#include <linux/poll.h>
+#include <linux/spinlock.h>
+#include <linux/delay.h>
+#include <linux/sched.h>
+#include <linux/interrupt.h>
+
+#include "xport_mips1900.h"
+#include "xport_drv1900.h"
+
+
+#ifdef CONFIG_ORION_XPORT_DEBUG
+#define DEBUG(n, args...)				\
+	do {						\
+		if (n <= CONFIG_XPORT_DEBUG_VERBOSE)	\
+		printk(KERN_INFO args);		\
+	} while(0)
+#else /* CONFIG_XPORT_DEBUG */
+#define DEBUG(n, args...) do { } while(0)
+#endif
+
+
+typedef enum
+{
+	FW_NO_REPLAY = 0,
+	FW_PREPARED = 1		
+}FW_STATUS;
+
+
+
+DEFINE_SEMAPHORE(mips_cmd_sem);
+
+
+
+/*get enable flag from  request addr in pull time*/
+static unsigned int xport_pull_mips(int addr,unsigned int delay,unsigned int n, struct semaphore *sem)
+{
+	unsigned int ret = FW_PREPARED;
+	unsigned int pull_cnt = n;
+	unsigned int reg_v = 0;
+
+
+	do
+	{/*read enable flag of request info in mail box addr*/
+		reg_v = xport_readl(addr);
+		udelay(delay);
+	}
+	while((pull_cnt-- > 0) && xport_get_bit(reg_v,31));
+
+	if (xport_get_bit(reg_v, 31))
+	{
+		ret = FW_NO_REPLAY;		
+		up(sem);
+	}
+
+
+	return ret;
+}
+
+
+int xport_mips_write(unsigned int cmd, unsigned int req_dat)
+{
+	unsigned int cnt = 1000;
+
+	union firmware_req req ;
+
+	req.val = cmd;
+	req.val = xport_set_bit(xport_set_bit(req.val,31),30);
+	/* bit31 = 1, indicates that will have a request */
+	/* bit30 = 1, indicates that a request will send to firmware */
+
+	if (down_interruptible(&mips_cmd_sem)) {
+		DEBUG(" mips_write error: down_interruptible () \n");
+		return -1;
+	}
+
+	if(FW_NO_REPLAY == xport_pull_mips(MIPS_CMD_REQ,50,cnt,&mips_cmd_sem))
+	{
+		printk("[lixun] mips_write error: timeout \n");
+		return -1;
+	}
+
+
+	//printk("[lixun]cmd = 0x%0x   data = 0x%08x\n", req.val, req_dat);
+
+	xport_writel(MIPS_CMD_DATA, req_dat);	/* write a request to firmware */
+	xport_writel(MIPS_CMD_REQ, req.val);
+
+	up(&mips_cmd_sem);
+
+	return 0;
+}
+
+
+int xport_mips_read(unsigned int cmd, unsigned int *req_dat)
+{
+
+	unsigned int cnt = 1000;
+	union firmware_req req  ;
+
+
+	req.val = cmd;
+	req.val = xport_set_bit(req.val,31) ;
+	/* bit31 = 1, indicates that will have a request */
+	/* bit30 = 0, indicates that get information from firmware */
+
+	if(down_interruptible(&mips_cmd_sem)) 
+	{
+		DEBUG(" mips_read error: down_interruptible () \n");
+		return -1;
+	}
+
+
+	if(FW_NO_REPLAY == xport_pull_mips(MIPS_CMD_REQ,50,cnt,&mips_cmd_sem))
+	{
+		printk(" mips_read error: timeout0 \n");
+		return -1;
+	}
+
+
+	xport_writel(MIPS_CMD_REQ, req.val);	/* send read-request to firmware */
+	udelay(50);
+	cnt = 1000;
+
+
+	if(FW_NO_REPLAY == xport_pull_mips(MIPS_CMD_REQ,50,cnt,&mips_cmd_sem))
+	{
+		printk(" mips_read error: timeout0 \n");
+		return -1;
+	}
+
+
+	*req_dat = xport_readl(MIPS_CMD_DATA);
+	up(&mips_cmd_sem);
+
+	return 0;
+}
+
+int xport_mips_read_ex(unsigned int cmd, unsigned int *req_dat, unsigned int *req_dat2)
+{
+	unsigned int cnt = 1000;
+	union firmware_req req;
+
+	req.val = cmd;
+	req.val = xport_set_bit(req.val,31);
+	/* bit31 = 1, indicates that will have a request */
+	/* bit30 = 0, indicates that get information from firmware */
+
+	if (down_interruptible(&mips_cmd_sem)) {
+		DEBUG(" mips_read error: down_interruptible () \n");
+		return -1;
+	}
+
+	if(FW_NO_REPLAY == xport_pull_mips(MIPS_CMD_REQ,50,cnt,&mips_cmd_sem))
+	{
+		DEBUG(KERN_INFO " mips_read error: timeout0 \n");
+		return -1;   	  
+	}
+
+
+	xport_writel(MIPS_CMD_REQ, req.val);	/* send read-request to firmware */
+	udelay(50);
+	cnt = 1000;
+
+
+	if(FW_NO_REPLAY == xport_pull_mips(MIPS_CMD_REQ,50,cnt,&mips_cmd_sem))
+	{
+		DEBUG(KERN_INFO " mips_read error: timeout1 \n");
+		return -1;   	  
+	}
+
+
+	*req_dat = xport_readl(MIPS_CMD_DATA);
+	*req_dat2 = xport_readl(MIPS_CMD_DATA2);
+	up(&mips_cmd_sem);
+
+	return 0;
+}
+
+EXPORT_SYMBOL(xport_mips_write);
+EXPORT_SYMBOL(xport_mips_read);
+EXPORT_SYMBOL(xport_mips_read_ex);
+
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_mips1900.h linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_mips1900.h
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_mips1900.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_mips1900.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,73 @@
+
+#ifndef __XPORT_MIPS1900_H__
+#define __XPORT_MIPS1900_H__
+
+#include "xport_regs1900.h"
+
+
+/*x stand for channel index. here Max to 19*/
+#define MIPS_CHL_EN(x)                  ((x<<8)|MIPS_OUTCHL_EN)
+
+/****n~(0,11)  x~(0,60) .note: pid0 can be used in every filter.
+  but  pid1-pid11 should be used only in PVR channel (filter 63)**/
+#define MIPS_CHL_PID(n,x)               ((x<<8)|MIPS_OUTCHL_PID(n))
+#define MIPS_CHL_FILTER0(x)             ((x<<8)|MIPS_OUTCHL_FILTER0)
+#define MIPS_CHL_FILTER1(x)             ((x<<8)|MIPS_OUTCHL_FILTER1)
+#define MIPS_CHL_FILTER2(x)             ((x<<8)|MIPS_OUTCHL_FILTER2)
+#define MIPS_CHL_MASK0(x)               ((x<<8)|MIPS_OUTCHL_MASK0)
+#define MIPS_CHL_MASK1(x)               ((x<<8)|MIPS_OUTCHL_MASK1)
+#define MIPS_CHL_MASK2(x)               ((x<<8)|MIPS_OUTCHL_MASK2)
+#define MIPS_CHL_DIR_LOW_ADDR(x)        ((x<<8)|MIPS_OUTCHL_DIR_LOW_ADRR)
+#define MIPS_CHL_DIR_UP_ADDR(x)         ((x<<8)|MIPS_OUTCHL_DIR_UP_ADRR)
+#define MIPS_CHL_WP(x)                  ((x<<8)|MIPS_OUTCHL_DIR_WP)
+#define MIPS_CHL_TC0_ERR_CNT(x)         ((x<<8)|MIPS_OUTCHL_BUF_TC0_ERR_CNT)
+#define MIPS_CHL_TC1_ERR_CNT(x)         ((x<<8)|MIPS_OUTCHL_BUF_TC1_ERR_CNT)
+#define MIPS_CHL_TC2_ERR_CNT(x)         ((x<<8)|MIPS_OUTCHL_BUF_TC2_ERR_CNT)
+#define MIPS_CHL_TC3_ERR_CNT(x)         ((x<<8)|MIPS_OUTCHL_BUF_TC3_ERR_CNT)
+#define MIPS_CHL_ERR_PKT_CNT(x)         ((x<<8)|MIPS_OUTCHL_BUF_ERR_PACKET_CNT)
+#define MIPS_CHL_OUT_PKT_CNT(x)         ((x<<8)|MIPS_OUTCHL_BUF_OUT_PACKET_CNT)
+#define MIPS_CHL_BUF_LOW_ADDR(x)        ((x<<8)|MIPS_OUTCHL_BUF_LOW_ADRR)
+#define MIPS_CHL_BUF_UP_ADDR(x)         ((x<<8)|MIPS_OUTCHL_BUF_UP_ADRR)
+#define MIPS_PCR_PID(x)                 ((x<<8)|MIPS_PCR_PID_ADDR)
+#define MIPS_PCR_GET(x)                 ((x<<8)|MIPS_PCR_GET_ADDR)
+#define MIPS_CHL_CRC_EN(x)              ((x<<8)|MIPS_OUTCHL_CRC_EN)
+#define MIPS_CHL_CRC_NOTIFY_EN(x)       ((x<<8)|MIPS_OUTCHL_CRC_NOTIFY_EN)
+#define MIPS_CHL_DISABLE(x)             ((x<<8)|MIPS_OUTCHL_DISABLE)
+#define MIPS_CHL_SWITCH(x)              ((x<<8)|MIPS_OUTCHL_SWITCH)
+#define MIPS_CHL_EXTERNAL_BASE(x)       (((x)<<8)|MIPS_EXTERNAL_BASE)
+#define MIPS_CHL_BITWISE0(x)            (((x)<<8)|MIPS_OUTCHL_BITWISE0)
+#define MIPS_CHL_BITWISE1(x)            (((x)<<8)|MIPS_OUTCHL_BITWISE1)
+#define MIPS_CHL_BITWISE2(x)            (((x)<<8)|MIPS_OUTCHL_BITWISE2)
+#define MIPS_CHL_FILTER_MAX_SIZE(x)     (((x)<<8)|MIPS_OUTCHL_FILTER_MAX_SIZE) 
+
+
+/**I/D ram addr for storeing firmware message**/
+#define MIPS_FW_WRITE_DATA              (0xc1400000+(0x4000<<2))
+#define MIPS_FW_WRITE_INST              (0xc1400000+(0x2000<<2))
+#define MIPS_FW_EN                      (0xc1400000+(0x6000<<2))
+
+/*firmware appoint MBOX0/1/4 as its info exchange to host for communicate*/
+#define MIPS_CMD_REQ 	                MAIL_BOX_ADDR(0)
+#define MIPS_CMD_DATA	                MAIL_BOX_ADDR(1)
+#define MIPS_CMD_DATA2	                MAIL_BOX_ADDR(4)
+
+
+union firmware_req {
+
+	struct {
+		unsigned int req_type:8;
+		unsigned int output_idx:8;
+		unsigned int reserved:14;
+		unsigned int rw:1;
+		unsigned int enable:1;
+	} bits;
+
+	unsigned int val;
+};
+
+int xport_mips_write(unsigned int cmd, unsigned int req_dat);
+int xport_mips_read(unsigned int cmd, unsigned int *req_dat);
+int xport_mips_read_ex(unsigned int cmd, unsigned int *req_dat, unsigned int *req_dat2);
+
+#endif
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_regs1900.h linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_regs1900.h
--- linux-linaro-3.4-2012.05-1_original/drivers/celestial/xport/xport_regs1900.h	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/celestial/xport/xport_regs1900.h	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,169 @@
+#ifndef _XPORT_REGS1900_H__
+#define _XPORT_REGS1900_H__
+
+
+#define xport_set_bit(v,n)                (v|(0x1<<(n)))
+#define xport_cls_bit(v,n)                (v&~(0x1<<(n)))
+#define xport_get_bit(v,n)                (((v)>>(n))&0x1)
+#define xport_get_bits(v,m,n)/*m>=n*/     ((v<<(31-m))>>(31-m+n))
+
+#define XPORT_REG_ADDR_BASE         PA_XPORT_REG_BASE
+
+/***********************HW Register Define********************/
+
+/************************Mail Box Addr0-7**********************/
+#define XPORT_REG_OFST              0x4
+#define MAIL_BOX_ADDR(n)            (XPORT_REG_ADDR_BASE+((n)*XPORT_REG_OFST))
+
+
+/************************Xport Config Addr**********************/
+#define XPORT_CFG_ADDR0             (XPORT_REG_ADDR_BASE+0x20)
+#define XPORT_CFG_ADDR1             (XPORT_REG_ADDR_BASE+0x24)
+
+
+/*********************Xport Config to Tuner Addr******************/
+#define XPORT_TUN_STS_ADDR          (XPORT_REG_ADDR_BASE+0x28)
+#define XPORT_TUN_STS_CFG_ADDR      (XPORT_REG_ADDR_BASE+0x2C)
+#define DMA_INPUT0_HEAD_ADDR        (XPORT_REG_ADDR_BASE+0x30)
+#define DMA_INPUT1_HEAD_ADDR        (XPORT_REG_ADDR_BASE+0x34)
+
+
+/*******************Xport Raw Interrupt Reg Addr******************/
+#define XPORT_INT_RAW_REG_ADDR0     (XPORT_REG_ADDR_BASE+0x38)
+#define XPORT_INT_RAW_REG_ADDR1     (XPORT_REG_ADDR_BASE+0x3C)
+
+
+/*******************Xport Interrupt Reg Addr0*********************/
+#define XPORT_INT_REG_ADDR0         (XPORT_REG_ADDR_BASE+0x40)
+#define XPORT_INT_ENB_ADDR0         (XPORT_REG_ADDR_BASE+0x44)
+#define XPORT_INT_SET_ADDR0         (XPORT_REG_ADDR_BASE+0x48)
+#define XPORT_INT_CLS_ADDR0         (XPORT_REG_ADDR_BASE+0x4C)
+
+
+/*******************Xport Interrupt Reg Addr1*********************/
+#define XPORT_INT_REG_ADDR1         (XPORT_REG_ADDR_BASE+0x50)
+#define XPORT_INT_ENB_ADDR1         (XPORT_REG_ADDR_BASE+0x54)
+#define XPORT_INT_SET_ADDR1         (XPORT_REG_ADDR_BASE+0x58)
+#define XPORT_INT_CLS_ADDR1         (XPORT_REG_ADDR_BASE+0x5C)
+#define XPORT_INT_EXT_ADDR          (MAIL_BOX_ADDR(5))
+
+
+/********************Xport  Enable Tuner0/1**********************/
+#define XPORT_TUNER_EN              (XPORT_REG_ADDR_BASE+0x60)
+
+
+/*************Input channel update configure register****************/
+#define XPORT_IN_CHL_UP_CFG         (XPORT_REG_ADDR_BASE+0x64)
+#define XPORT_TSOUT_GAP             (XPORT_REG_ADDR_BASE+0x68)
+
+#define CLK0_STC_HIGH_ADDR          (XPORT_REG_ADDR_BASE+0x80)
+#define CLK0_STC_LOW_ADDR           (XPORT_REG_ADDR_BASE+0x84)
+
+#define CLK0_PCR_HIGH_ADDR          (XPORT_REG_ADDR_BASE+0x88)
+#define CLK0_PCR_LOW_ADDR           (XPORT_REG_ADDR_BASE+0x8C)
+
+#define CLK0_PCR_CNT_ADDR           (XPORT_REG_ADDR_BASE+0x90)
+#define CLK0_PCR_INTERVAL_ADDR      (XPORT_REG_ADDR_BASE+0x94)
+
+
+/*************Xport Clock Component Addr************************/
+#define CLK0_DELTA_CYL_ADDR         (XPORT_REG_ADDR_BASE+0x98)
+#define CLK0_DELTA_CYL_THRS_ADDR    (XPORT_REG_ADDR_BASE+0x9C)
+#define CLK0_PWM_CTRL_ADDR          (XPORT_REG_ADDR_BASE+0xA4)
+#define CLK0_PWM_CWORD_ADDR         (XPORT_REG_ADDR_BASE+0xA8)
+#define CLK0_PCR_VALID_ADDR         (XPORT_REG_ADDR_BASE+0xAC)
+#define CLK0_REC_DELAY_TIME_ADDR    (XPORT_REG_ADDR_BASE+0xB0)
+#define CLK0_CLK_CNT_ADDR           (XPORT_REG_ADDR_BASE+0xB4)
+
+
+/**********Xport input channel generate macro Addr *****************/
+#define IN_CHL_BASE_ADDR(n)         ((n)==0?IN_CHL0_BASE_ADDR: IN_CHL1_BASE_ADDR)
+#define IN_CHL_CFG_ADDR(n)          ((n)==0?IN_CHL0_CFG_ADDR : IN_CHL1_CFG_ADDR)
+#define IN_CHL_RP_ADDR(n)           ((n)==0?IN_CHL0_RP_ADDR  : IN_CHL1_RP_ADDR)
+#define IN_CHL_WP_ADDR(n)           ((n)==0?IN_CHL0_WP_ADDR  : IN_CHL1_WP_ADDR)
+
+
+/*************Xport input Channel0 Option Addr ********************/
+#define IN_CHL0_BASE_ADDR           (XPORT_REG_ADDR_BASE+0x100)
+#define IN_CHL0_CFG_ADDR            (XPORT_REG_ADDR_BASE+0x104)
+#define IN_CHL0_RP_ADDR             (XPORT_REG_ADDR_BASE+0x108)
+#define IN_CHL0_WP_ADDR             (XPORT_REG_ADDR_BASE+0x10C)
+
+
+/*************Xport input Channel1 Option Addr ********************/
+#define IN_CHL1_BASE_ADDR           (XPORT_REG_ADDR_BASE+0x118)
+#define IN_CHL1_CFG_ADDR            (XPORT_REG_ADDR_BASE+0x11C)
+#define IN_CHL1_RP_ADDR             (XPORT_REG_ADDR_BASE+0x120)
+#define IN_CHL1_WP_ADDR             (XPORT_REG_ADDR_BASE+0x124)
+
+
+/****xunli: direct dma mode ****/
+#define XPORT_CHL_DMA_WP_ADDR(n)    ((n)<2?MAIL_BOX_ADDR(n+2): MAIL_BOX_ADDR(n+4))
+#define XPORT_CHL_DMA0_WP_ADDR      (MAIL_BOX_ADDR(2))
+#define XPORT_CHL_DMA1_WP_ADDR      (MAIL_BOX_ADDR(3))
+#define XPORT_CHL_DMA2_WP_ADDR      (MAIL_BOX_ADDR(6))
+#define XPORT_CHL_DMA3_WP_ADDR      (MAIL_BOX_ADDR(7))
+
+
+/********For Setting Xport filter Group0/1 (0-63/64-128)**************/
+
+#define __PID_FILTER__(n) (n>63?PID_GRP1_FLTR(n): PID_GRP0_FLTR(n))
+/***Set Pid filter Reg 0-63***/
+#define FLTR_PID_ADDR_BASE0         (0x180+XPORT_REG_ADDR_BASE)
+#define PID_GRP0_FLTR(n)            (FLTR_PID_ADDR_BASE0+(XPORT_REG_OFST*(n)))
+
+
+/***Set Pid filter Reg 64-127***/
+#define FLTR_PID_ADDR_BASE1         (0xC00+XPORT_REG_ADDR_BASE)
+#define PID_GRP1_FLTR(n)            (FLTR_PID_ADDR_BASE1+(XPORT_REG_OFST*(n-64)))
+
+
+/******************Xport Descramble Reg Addr Base***********************/
+#define DSCRB_REG_ODD_BASE          (XPORT_REG_ADDR_BASE+0x280)
+#define DSCRB_REG_EVN_BASE          (XPORT_REG_ADDR_BASE+0x298)
+
+/**i~(0,5) for Key Cnt.   j~(0,7) for Group Cnt**/
+#define __DSCRB_ODD_ADDR_(i, j)     (DSCRB_REG_ODD_BASE+(XPORT_REG_OFST*(i))+(0x30*(j)))
+#define __DSCRB_EVN_ADDR_(i, j)     (DSCRB_REG_EVN_BASE+(XPORT_REG_OFST*(i))+(0x30*(j)))
+
+
+/**32 output channel define ?**/
+/******************MIPS software Register define************************/
+
+#define MIPS_OUTCHL_EN                   0x0000
+#define MIPS_OUTCHL_FILTER0              0x0001
+#define MIPS_OUTCHL_FILTER1              0x0002
+#define MIPS_OUTCHL_FILTER2              0x0003
+#define MIPS_OUTCHL_MASK0                0x0004
+#define MIPS_OUTCHL_MASK1                0x0005
+#define MIPS_OUTCHL_MASK2                0x0006
+#define MIPS_OUTCHL_DIR_LOW_ADRR         0x0007
+#define MIPS_OUTCHL_DIR_UP_ADRR          0x0008
+#define MIPS_OUTCHL_DIR_WP               0x0009
+#define MIPS_OUTCHL_BUF_TC0_ERR_CNT      0x000a
+#define MIPS_OUTCHL_BUF_TC1_ERR_CNT      0x000b
+#define MIPS_OUTCHL_BUF_TC2_ERR_CNT      0x000c
+#define MIPS_OUTCHL_BUF_TC3_ERR_CNT      0x000d
+#define MIPS_OUTCHL_BUF_ERR_PACKET_CNT   0x000e
+#define MIPS_OUTCHL_BUF_OUT_PACKET_CNT   0x000f
+#define MIPS_OUTCHL_BUF_LOW_ADRR         0x0010
+#define MIPS_OUTCHL_BUF_UP_ADRR          0x0011
+#define MIPS_PCR_PID_ADDR                0x0012
+#define MIPS_PCR_GET_ADDR                0x0013
+#define MIPS_OUTCHL_CRC_EN               0x0014
+#define MIPS_OUTCHL_CRC_NOTIFY_EN        0x0015
+#define MIPS_OUTCHL_PID_BASE             0x0016
+
+/*n~(0,16)*/
+#define MIPS_OUTCHL_PID(n)               (MIPS_OUTCHL_PID_BASE+(n))
+#define MIPS_OUTCHL_DISABLE              (MIPS_OUTCHL_PID_BASE + 0x20)
+#define MIPS_OUTCHL_SWITCH               (MIPS_OUTCHL_PID_BASE + 0x21)
+#define  MIPS_EXTERNAL_BASE              (MIPS_OUTCHL_PID_BASE + 0x22)
+#define  MIPS_OUTCHL_BITWISE0            (MIPS_OUTCHL_PID_BASE + 0x23)
+#define  MIPS_OUTCHL_BITWISE1            (MIPS_OUTCHL_PID_BASE + 0x24)
+#define  MIPS_OUTCHL_BITWISE2            (MIPS_OUTCHL_PID_BASE + 0x25)
+#define  MIPS_OUTCHL_FILTER_MAX_SIZE     (MIPS_OUTCHL_PID_BASE + 0x26)
+
+#define MIPS_INCHL_TYPE                  (MIPS_OUTCHL_PID_BASE + 0x27)
+#endif
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/cpufreq/cnc1900_cpufreq_drv.c linux-linaro-3.4-2012.05-1_cavium/drivers/cpufreq/cnc1900_cpufreq_drv.c
--- linux-linaro-3.4-2012.05-1_original/drivers/cpufreq/cnc1900_cpufreq_drv.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/cpufreq/cnc1900_cpufreq_drv.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,200 @@
+/*
+ * Copyright 2013 caviumnetworks,inc
+ *
+ * Cavium CNC1900 CPUfreq Support
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation.
+ */
+
+#define pr_fmt(fmt) "cpufreq: " fmt
+
+#include <linux/kernel.h>
+#include <linux/types.h>
+#include <linux/init.h>
+#include <linux/cpufreq.h>
+#include <linux/clk.h>
+#include <linux/err.h>
+#include <linux/regulator/consumer.h>
+#include <linux/module.h>
+#include <linux/interrupt.h>
+#include <linux/vmalloc.h>
+
+static struct cpufreq_frequency_table *cnc1900_freq_table = NULL;
+#if 0
+[] = {
+	{ 0,  27000  },
+	{ 1,  54000  },
+	{ 2,  81000  },
+	{ 3,  108000 },
+	{ 4,  135000 },
+	{ 5,  162000 },
+	{ 6,  189000 },
+	{ 7,  216000 },
+	{ 8,  243000 },
+	{ 9,  270000 },
+	{ 10, 297000 },
+	{ 11, 324000 },
+	{ 12, 351000 },
+	{ 13, 378000 },
+	{ 14, 405000 },
+	{ 15, 432000 },
+	{ 16, 459000 },
+	{ 17, 486000 },
+	{ 18, 513000 },
+	{ 19, 540000 },
+	{ 20, 567000 },
+	{ 21, 594000 },
+	{ 22, 621000 },
+	{ 23, 648000 },
+#if (1==CONFIG_CACHE_L2X0)
+	{ 24, 675000 },
+	{ 25, 702000 },
+	{ 26, 729000 },
+	{ 27, 756000 },
+	{ 28, 783000 },
+	{ 29, 810000 },
+#endif		
+	{ 0, CPUFREQ_TABLE_END },
+};
+#endif
+extern unsigned int cnc1900_get_cpufreq(void);
+extern void cnc1900_set_cpufreq(unsigned int target_freq);
+extern int cnc1900_cpufreq_plat_init(void);
+
+static int cnc1900_cpufreq_verify_speed(struct cpufreq_policy *policy)
+{
+	if (policy->cpu != 0)
+		return -EINVAL;
+
+	return cpufreq_frequency_table_verify(policy, cnc1900_freq_table);
+}
+
+static unsigned int cnc1900_cpufreq_get_speed(unsigned int cpu)
+{
+	if (cpu != 0)
+		return 0;
+
+	return cnc1900_get_cpufreq() / 1000;
+}
+
+static int cnc1900_cpufreq_set_target(struct cpufreq_policy *policy,
+				      unsigned int target_freq,
+				      unsigned int relation)
+{
+	int ret;
+	unsigned int i;
+	struct cpufreq_freqs freqs;
+
+	ret = cpufreq_frequency_table_target(policy, cnc1900_freq_table,
+					     target_freq, relation, &i);
+	if (ret != 0)
+		return ret;
+
+	freqs.cpu = 0;
+	freqs.old = cnc1900_get_cpufreq() / 1000;
+	freqs.new = cnc1900_freq_table[i].frequency;
+	freqs.flags = 0;
+
+	if (freqs.old == freqs.new)
+		return 0;
+
+	pr_debug("Transition %d-%dkHz\n", freqs.old, freqs.new);
+
+	cpufreq_notify_transition(&freqs, CPUFREQ_PRECHANGE);
+
+	cnc1900_set_cpufreq(freqs.new * 1000);
+
+	cpufreq_notify_transition(&freqs, CPUFREQ_POSTCHANGE);
+
+	pr_debug("Set actual frequency %dkHz\n",freqs.new);
+
+	return 0;
+}
+
+static int cnc1900_cpufreq_driver_init(struct cpufreq_policy *policy)
+{
+	int ret;
+
+	if (policy->cpu != 0)
+		return -EINVAL;
+
+	if (cnc1900_freq_table == NULL) {
+		pr_err("No frequency information for this CPU\n");
+		return -ENODEV;
+	}
+	policy->cur = cnc1900_get_cpufreq() / 1000;
+
+	policy->cpuinfo.transition_latency = 300 * 1000;
+
+	ret = cpufreq_frequency_table_cpuinfo(policy, cnc1900_freq_table);
+	if (ret != 0) {
+		pr_err("Failed to configure frequency table: %d\n",
+		       ret);
+	}
+
+	cnc1900_cpufreq_plat_init();
+
+	return ret;
+}
+
+static struct cpufreq_driver cnc1900_cpufreq_driver = {
+	.owner		= THIS_MODULE,
+	.flags      = 0,
+	.verify		= cnc1900_cpufreq_verify_speed,
+	.target		= cnc1900_cpufreq_set_target,
+	.get		= cnc1900_cpufreq_get_speed,
+	.init		= cnc1900_cpufreq_driver_init,
+	.name		= "cnc1900 cpufreq",
+};
+
+/*
+ * This function prepare available cpu frequencies based on the initial frequency for cnc1900.
+ * This module is statically linked, so we don't consider the initial frequency changing by module dynamicly load. 
+ */
+static void __init cnc1900_cpufreq_prepare_freq_tbl(void)
+{
+#define CNC1900_FREQ_STEP   27000
+    unsigned int freq;
+    unsigned int min_freq = CNC1900_FREQ_STEP;
+    unsigned int i;
+    unsigned int max_freq = cnc1900_get_cpufreq() / 1000;
+    unsigned int freq_cnt = 0;
+
+    WARN_ON(NULL != cnc1900_freq_table);
+    freq_cnt = max_freq/CNC1900_FREQ_STEP;
+    cnc1900_freq_table = vmalloc(freq_cnt*sizeof(struct cpufreq_frequency_table));
+    
+    for(i = 0,freq = min_freq;freq <= max_freq;i++,freq += CNC1900_FREQ_STEP)
+    {
+      cnc1900_freq_table[i].index = i;
+      cnc1900_freq_table[i].frequency = freq;
+    }
+
+    cnc1900_freq_table[i].index = 0;
+    cnc1900_freq_table[i].frequency = CPUFREQ_TABLE_END;
+  
+    printk("cnc1900 cpufreq init,freq interval=[%dKHz,%dKHz],step=%dKHz.\n",min_freq,cnc1900_freq_table[i-1].frequency,CNC1900_FREQ_STEP);
+}
+
+static void __exit cnc1900_cpufreq_exit(void)
+{
+  vfree(cnc1900_freq_table);
+  cnc1900_freq_table=NULL;
+}
+
+static int __init cnc1900_cpufreq_init(void)
+{
+  cnc1900_cpufreq_prepare_freq_tbl();
+	return cpufreq_register_driver(&cnc1900_cpufreq_driver);
+}
+
+MODULE_LICENSE("GPL");
+MODULE_AUTHOR("Yu.Lei <yu.lei@caviumnetworks.com>");
+MODULE_DESCRIPTION("cpufreq driver for caviumnetworks's cnc1900 SOC");
+
+module_init(cnc1900_cpufreq_init);
+module_exit(cnc1900_cpufreq_exit);
+
+
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/cpufreq/Kconfig.arm linux-linaro-3.4-2012.05-1_cavium/drivers/cpufreq/Kconfig.arm
--- linux-linaro-3.4-2012.05-1_original/drivers/cpufreq/Kconfig.arm	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/cpufreq/Kconfig.arm	2014-07-29 17:28:38.819972000 +0800
@@ -76,3 +76,12 @@
 	help
 	  This adds the CPUFreq driver for Samsung EXYNOS5250
 	  SoC.
+
+config ARM_CELESTIAL_CNC1900_CPUFREQ
+	bool "CELESTIAL_CNC1900"
+	depends on MACH_CELESTIAL_CNC1900 && CACHE_L2X0
+	default y
+	help
+	  This adds the CPUFreq driver for CELESTIAL CNC1900 SoC.
+
+	  If in doubt, say N.
\ No newline at end of file
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/cpufreq/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/cpufreq/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/cpufreq/Makefile	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/cpufreq/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -51,6 +51,7 @@
 obj-$(CONFIG_ARM_EXYNOS4X12_CPUFREQ)	+= exynos4x12-cpufreq.o
 obj-$(CONFIG_ARM_EXYNOS5250_CPUFREQ)	+= exynos5250-cpufreq.o
 obj-$(CONFIG_ARM_OMAP2PLUS_CPUFREQ)     += omap-cpufreq.o
+obj-$(CONFIG_ARM_CELESTIAL_CNC1900_CPUFREQ)     += cnc1900_cpufreq_drv.o
 
 ##################################################################################
 # PowerPC platform drivers
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/hid/hid-core.c linux-linaro-3.4-2012.05-1_cavium/drivers/hid/hid-core.c
--- linux-linaro-3.4-2012.05-1_original/drivers/hid/hid-core.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/hid/hid-core.c	2014-07-29 17:28:38.819972000 +0800
@@ -1158,7 +1158,7 @@
 static bool hid_match_one_id(struct hid_device *hdev,
 		const struct hid_device_id *id)
 {
-	return id->bus == hdev->bus &&
+	return (id->bus == HID_BUS_ANY || id->bus == hdev->bus) &&
 		(id->vendor == HID_ANY_ID || id->vendor == hdev->vendor) &&
 		(id->product == HID_ANY_ID || id->product == hdev->product);
 }
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/hid/hid-generic.c linux-linaro-3.4-2012.05-1_cavium/drivers/hid/hid-generic.c
--- linux-linaro-3.4-2012.05-1_original/drivers/hid/hid-generic.c	1970-01-01 08:00:00.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/hid/hid-generic.c	2014-07-29 17:28:38.819972000 +0800
@@ -0,0 +1,60 @@
+/*
+ *  HID support for Linux
+ *
+ *  Copyright (c) 1999 Andreas Gal
+ *  Copyright (c) 2000-2005 Vojtech Pavlik <vojtech@suse.cz>
+ *  Copyright (c) 2005 Michael Haboustak <mike-@cinci.rr.com> for Concept2, Inc
+ *  Copyright (c) 2007-2008 Oliver Neukum
+ *  Copyright (c) 2006-2012 Jiri Kosina
+ *  Copyright (c) 2012 Henrik Rydberg
+ *  Copyright (c) 2014 Andrzej Kaczmarek
+ */
+
+/*
+ * This program is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License as published by the Free
+ * Software Foundation; either version 2 of the License, or (at your option)
+ * any later version.
+ */
+
+#include <linux/module.h>
+#include <linux/slab.h>
+#include <linux/kernel.h>
+#include <asm/unaligned.h>
+#include <asm/byteorder.h>
+
+#include <linux/hid.h>
+
+static const struct hid_device_id hid_generic_devices[] = {
+	{ HID_DEVICE(HID_BUS_ANY, HID_ANY_ID, HID_ANY_ID) },
+	{ }
+};
+MODULE_DEVICE_TABLE(hid, hid_generic_devices);
+
+static struct hid_driver hid_generic_driver = {
+	.name = "hid-generic",
+	.id_table = hid_generic_devices,
+};
+
+static int __init hid_generic_init2(void)
+{
+	int ret;
+
+	ret = hid_register_driver(&hid_generic_driver);
+	if (ret)
+		pr_err("can't register hid-generic driver\n");
+
+	return ret;
+}
+
+static void __exit hid_generic_exit2(void)
+{
+	hid_unregister_driver(&hid_generic_driver);
+}
+
+module_init(hid_generic_init2);
+module_exit(hid_generic_exit2);
+
+MODULE_AUTHOR("Henrik Rydberg");
+MODULE_DESCRIPTION("HID generic driver");
+MODULE_LICENSE("GPL");
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/hid/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/hid/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/hid/Makefile	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/hid/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -33,6 +33,7 @@
 	hid-wiimote-y	+= hid-wiimote-debug.o
 endif
 
+obj-y				+= hid-generic.o
 obj-$(CONFIG_HID_A4TECH)	+= hid-a4tech.o
 obj-$(CONFIG_HID_ACRUX)		+= hid-axff.o
 obj-$(CONFIG_HID_APPLE)		+= hid-apple.o
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/input/evdev.c linux-linaro-3.4-2012.05-1_cavium/drivers/input/evdev.c
--- linux-linaro-3.4-2012.05-1_original/drivers/input/evdev.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/input/evdev.c	2014-07-29 17:28:38.819972000 +0800
@@ -1084,8 +1084,20 @@
 
 MODULE_DEVICE_TABLE(input, evdev_ids);
 
+static bool evdev_match(struct input_handler *handler, struct input_dev *dev)
+{
+        #define VID_EETI 0x0EEF
+        /* Avoid EETI USB touchscreens */
+        if ((BUS_USB == dev->id.bustype) && (VID_EETI == dev->id.vendor))
+        {
+                return false;
+        }
+        return true;
+}
+
 static struct input_handler evdev_handler = {
 	.event		= evdev_event,
+        .match          = evdev_match,/* Added by EETI */
 	.connect	= evdev_connect,
 	.disconnect	= evdev_disconnect,
 	.fops		= &evdev_fops,
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/input/joydev.c linux-linaro-3.4-2012.05-1_cavium/drivers/input/joydev.c
--- linux-linaro-3.4-2012.05-1_original/drivers/input/joydev.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/input/joydev.c	2014-07-29 17:28:38.819972000 +0800
@@ -791,6 +791,11 @@
 	if (test_bit(EV_KEY, dev->evbit) && test_bit(BTN_DIGI, dev->keybit))
 		return false;
 
+        /* Avoid EETI virtual devices */
+#define VID_EETI 0x0EEF
+        if ((BUS_VIRTUAL == dev->id.bustype) && (VID_EETI == dev->id.vendor))
+                return false;
+
 	return true;
 }
 
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/input/mousedev.c linux-linaro-3.4-2012.05-1_cavium/drivers/input/mousedev.c
--- linux-linaro-3.4-2012.05-1_original/drivers/input/mousedev.c	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/input/mousedev.c	2014-07-29 17:28:38.819972000 +0800
@@ -1054,8 +1054,25 @@
 
 MODULE_DEVICE_TABLE(input, mousedev_ids);
 
+static bool mousedev_match(struct input_handler *handler, struct input_dev *dev)
+{
+#define VID_EETI 0x0EEF
+        /* Avoid EETI USB touchscreens */
+        if ((BUS_USB == dev->id.bustype) && (VID_EETI == dev->id.vendor))
+        {
+                return false;
+        }
+        /* Avoid EETI virtual devices */
+        if ((BUS_VIRTUAL == dev->id.bustype) && (VID_EETI == dev->id.vendor))
+        {
+                return false;
+        }
+        return true;
+}
+
 static struct input_handler mousedev_handler = {
 	.event =	mousedev_event,
+        .match =        mousedev_match,/* Added by EETI */
 	.connect =	mousedev_connect,
 	.disconnect =	mousedev_disconnect,
 	.fops =		&mousedev_fops,
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/Kconfig	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/Kconfig	2014-07-29 17:28:38.819972000 +0800
@@ -144,4 +144,6 @@
 
 source "drivers/gator/Kconfig"
 
+source "drivers/celestial/Kconfig"
+
 endmenu
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/Makefile	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -137,3 +137,5 @@
 obj-$(CONFIG_PM_DEVFREQ)	+= devfreq/
 
 obj-$(CONFIG_GATOR)		+= gator/
+#some celestial driver
+obj-y				+= celestial/
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/misc/Kconfig linux-linaro-3.4-2012.05-1_cavium/drivers/misc/Kconfig
--- linux-linaro-3.4-2012.05-1_original/drivers/misc/Kconfig	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/misc/Kconfig	2014-07-29 17:28:38.819972000 +0800
@@ -517,7 +517,11 @@
 	---help---
 	 Creates an rfkill entry in sysfs for power control of Bluetooth
 	 TI wl127x chips.
-	 
+
+config ANDROID_PMEM
+    bool "Android Pmem Allocator"
+    default n
+
 source "drivers/misc/c2port/Kconfig"
 source "drivers/misc/eeprom/Kconfig"
 source "drivers/misc/cb710/Kconfig"
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/misc/Makefile linux-linaro-3.4-2012.05-1_cavium/drivers/misc/Makefile
--- linux-linaro-3.4-2012.05-1_original/drivers/misc/Makefile	2012-05-23 00:39:37.000000000 +0800
+++ linux-linaro-3.4-2012.05-1_cavium/drivers/misc/Makefile	2014-07-29 17:28:38.819972000 +0800
@@ -52,3 +52,4 @@
 obj-$(CONFIG_MAX8997_MUIC)	+= max8997-muic.o
 obj-$(CONFIG_WL127X_RFKILL)	+= wl127x-rfkill.o
 obj-$(CONFIG_SENSORS_AK8975)	+= akm8975.o
+obj-$(CONFIG_ANDROID_PMEM)      += pmem.o
diff '--exclude=.svn' -Naur linux-linaro-3.4-2012.05-1_original/drivers/misc/pmem.c linux-linaro-3.4-2012.05-1_cavium/drivers/misc/pmem.c
